int NBALLS = 10000;

Ball[] balls;           // Declare an array of ball objects.
Grid buckets;

void setup()
{
  size(700, 700);
  balls = new Ball[NBALLS];
  for (int i=0; i<balls.length; i++)
  {
    balls[i] = new Ball();
  }
  buckets = new Grid();
}

void draw()
{
  background(254, 244, 232);  // Pale background.

  if (mousePressed) // magnifier
  {
    translate(width/2, height/2);
    scale(10);
    translate(-mouseX, -mouseY);
  }

  // First draw the balls in their current position.
  for (Ball ball : balls)
  {
    ball.draw();
  }

  // buckets.draw();
  buckets.checkCollisions();

  // Finally move all the balls by one step.
  for (Ball ball : balls)
  {
    ball.move();
  }
}
